      subroutine kinkk22(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
 
      implicit none
 
      integer, parameter :: nepl=8
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3,q4
      real(dp) :: sqsl1,sqsl2,sqsl3,sqsl4
      real(dp) :: sqsu1,sqsu2,sqsu3,sqsu4
      real(dp) :: sqs1,sqs2,sqs3,sqs4
      real(dp) :: ds1,ds2,ds3,ds4
      real(dp) :: s1,s2,s3,s4
      real(dp) :: dl1,dl2,dl3,dl4
 
      if (ikin == 421) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 422) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 423) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 424) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 425) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 426) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 427) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mu,gamu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(5),x(7:8),p(:,6),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 428) then
       sqsl1=m(6)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 429) then
       sqsl1=m(6)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 430) then
       sqsl1=m(6)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin == 431) then
       sqsl1=m(6)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl3+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,8)
        q4=q3+p(:,4)
       end if
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mt,gamt,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs3,m(4),x(11:12),q3,p(:,4),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 432) then
       sqsl1=m(6)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl3+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,8)
        q4=q3+p(:,4)
       end if
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mt,gamt,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs3,m(4),x(11:12),q3,p(:,4),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 433) then
       sqsl1=m(6)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl3+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,8)
        q4=q3+p(:,4)
       end if
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mt,gamt,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs3,m(4),x(11:12),q3,p(:,4),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 434) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(5)
       sqsl4=m(6)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,5)
        q4=p(:,6)+q3
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(9:10),q2,p(:,5),dl3)
       call kinff(imom,sqs4,m(6),sqs3,x(11:12),p(:,6),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 435) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(5)
       sqsl4=m(6)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,5)
        q4=p(:,6)+q3
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(9:10),q2,p(:,5),dl3)
       call kinff(imom,sqs4,m(6),sqs3,x(11:12),p(:,6),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 436) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(5)
       sqsl4=m(6)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,5)
        q4=p(:,6)+q3
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(9:10),q2,p(:,5),dl3)
       call kinff(imom,sqs4,m(6),sqs3,x(11:12),p(:,6),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 437) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=m(6)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=p(:,6)+q2
        q4=q3+p(:,5)
       end if
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mmu,gammu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(6),sqs2,x(9:10),p(:,6),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 438) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=m(6)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=p(:,6)+q2
        q4=q3+p(:,5)
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mmu,gammu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(6),sqs2,x(9:10),p(:,6),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 439) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=m(6)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=p(:,6)+q2
        q4=q3+p(:,5)
       end if
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mmu,gammu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(6),sqs2,x(9:10),p(:,6),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 440) then
       sqsl1=m(3)+m(4)
       sqsl2=m(7)+m(8)
       sqsl3=m(6)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,7)+p(:,8)
        q3=p(:,6)+q2
        q4=q3+p(:,5)
       end if
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mmu,gammu,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       call kinff(imom,sqs1,m(3),m(4),x(5:6),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(6),sqs2,x(9:10),p(:,6),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      end if
 
      end
